<!DOCTYPE html>
<html>
  <head>
    <title>SpinBox</title>
  </head>
  <body>
    <script>
      var module = (function () {
        function createSpinBox() {
          const wrapper = document.createElement("div");
          const numViewer = document.createElement("div");
          const plusBtn = document.createElement("button");
          const minusBtn = document.createElement("button");

          //
          let cnt = 0;
          let timer;
          let intervaler;

          function clearSpinTime(timer, intervaler) {
            clearTimeout(timer);
            clearInterval(intervaler);
          }

          //
          numViewer.textContent = cnt;
          numViewer.style.marginRight = "10px";
          plusBtn.textContent = "+";
          minusBtn.textContent = "-";
          wrapper.style.display = "flex";
          wrapper.append(numViewer, plusBtn, minusBtn);
          document.body.append(wrapper);

          //
          plusBtn.addEventListener("mousedown", function () {
            numViewer.textContent = ++cnt;

            timer = setTimeout(function () {
              intervaler = setInterval(() => {
                numViewer.textContent = ++cnt;
              }, 70);
            }, 1000);
          });

          plusBtn.addEventListener("mouseup", function () {
            clearInterval(intervaler);
            clearTimeout(timer);
          });

          //
          minusBtn.addEventListener("mousedown", function () {
            numViewer.textContent = --cnt;

            timer = setTimeout(function () {
              intervaler = setInterval(() => {
                numViewer.textContent = --cnt;
              }, 70);
            }, 1000);
          });

          minusBtn.addEventListener("mouseup", function () {
            clearInterval(intervaler);
            clearTimeout(timer);
          });
        }

        return {
          createSpinBox: createSpinBox,
        };
      })();

      module.createSpinBox();
      module.createSpinBox();
    </script>
  </body>
</html>
